#include <iostream>
#include <vector>
using namespace std;
int main()
{
    int N,Q;
    cin>>N>>Q;
    vector<long long> d(N),p(N),k(Q);
    for(int i=0;i<N;i++)
    {
        cin>>d[i]>>p[i];
    }
    for(int i=0;i<Q;i++)
    {
        cin>>k[i];
    }
    for(int j=0;j<Q;j++)
    {
        long long stanje = 0;
        long long sum= 0;
        long long brojac = 0;
        for(int i = 0;i<N;i++)
        {
            if(d[i] >k[j]) break;

            if(i==0)
            {
                sum += 1;
                stanje += p[i]- 1;
            }
            else
            {
               if(d[i] -d[i-1]- 1 > stanje)
               {
                   sum += stanje+ 1;
                   stanje = p[i] -1;
               }
               else{
                   sum += (d[i]- d[i-1] -1) +1;
                   stanje = stanje -(d[i] -d[i-1] - 1) -1 +p[i];
               }
            }
            brojac = i;
        }
        if(k[j] -d[brojac] - 1 > 0 && stanje > 0)
        {
            if(stanje > k[j]- d[brojac]- 1)
            {
                sum +=k[j] - d[brojac];
            }
            else
            {
                sum +=stanje;
            }
        }
        cout<<sum<<endl;
    }
    return 0;
}